<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (70)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="extending-built-in-classes">Extending built-in classes</h1>
    <p>Built-in classes like Array, Map and others are extendable also.</p>
    <p>
      For instance, here <code>PowerArray</code> inherits from the native
      <code>Array</code>:
    </p>
    <p>
      ```js run // add one more method to it (can do more) class PowerArray
      extends Array { isEmpty() { return this.length === 0; } }
    </p>
    <p>
      let arr = new PowerArray(1, 2, 5, 10, 50); alert(arr.isEmpty()); // false
    </p>
    <p>
      let filteredArr = arr.filter((item) =&gt; item &gt;= 10);
      alert(filteredArr); // 10, 50 alert(filteredArr.isEmpty()); // false ```
    </p>
    <p>
      Please note a very interesting thing. Built-in methods like
      <code>filter</code>, <code>map</code> and others – return new objects of
      exactly the inherited type <code>PowerArray</code>. Their internal
      implementation uses the object’s <code>constructor</code> property for
      that.
    </p>
    <p>In the example above,</p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="va">arr</span>.<span class="at">constructor</span> <span class="op">===</span> PowerArray<span class="op">;</span></a></code></pre>
    </div>
    <p>
      When <code>arr.filter()</code> is called, it internally creates the new
      array of results using exactly <code>arr.constructor</code>, not basic
      <code>Array</code>. That’s actually very cool, because we can keep using
      <code>PowerArray</code> methods further on the result.
    </p>
    <p>Even more, we can customize that behavior.</p>
    <p>
      We can add a special static getter <code>Symbol.species</code> to the
      class. If it exists, it should return the constructor that JavaScript will
      use internally to create new entities in <code>map</code>,
      <code>filter</code> and so on.
    </p>
    <p>
      If we’d like built-in methods like <code>map</code> or
      <code>filter</code> to return regular arrays, we can return
      <code>Array</code> in <code>Symbol.species</code>, like here:
    </p>
    <p>
      ```js run class PowerArray extends Array { isEmpty() { return this.length
      === 0; }
    </p>
    <p>
      <em>!</em> // built-in methods will use this as the constructor static get
      <a href="">Symbol.species</a> { return Array; } <em>/!</em> }
    </p>
    <p>
      let arr = new PowerArray(1, 2, 5, 10, 50); alert(arr.isEmpty()); // false
    </p>
    <p>
      // filter creates new array using arr.constructor[Symbol.species] as
      constructor let filteredArr = arr.filter(item =&gt; item &gt;= 10);
    </p>
    <p>
      <em>!</em> // filteredArr is not PowerArray, but Array
      <em>/!</em> alert(filteredArr.isEmpty()); // Error: filteredArr.isEmpty is
      not a function ```
    </p>
    <p>
      As you can see, now <code>.filter</code> returns <code>Array</code>. So
      the extended functionality is not passed any further.
    </p>
    <p>
      <code
        >smart header="Other collections work similarly" Other collections, such
        as `Map` and `Set`, work alike. They also use `Symbol.species`.</code
      >
    </p>
    <h2 id="no-static-inheritance-in-built-ins">
      No static inheritance in built-ins
    </h2>
    <p>
      Built-in objects have their own static methods, for instance
      <code>Object.keys</code>, <code>Array.isArray</code> etc.
    </p>
    <p>
      As we already know, native classes extend each other. For instance,
      <code>Array</code> extends <code>Object</code>.
    </p>
    <p>
      Normally, when one class extends another, both static and non-static
      methods are inherited. That was thoroughly explained in the article
      <a href="info:static-properties-methods#statics-and-inheritance"></a>.
    </p>
    <p>
      But built-in classes are an exception. They don’t inherit statics from
      each other.
    </p>
    <p>
      For example, both <code>Array</code> and <code>Date</code> inherit from
      <code>Object</code>, so their instances have methods from
      <code>Object.prototype</code>. But <code>Array.[[Prototype]]</code> does
      not reference <code>Object</code>, so there’s no, for instance,
      <code>Array.keys()</code> (or <code>Date.keys()</code>) static method.
    </p>
    <p>
      Here’s the picture structure for <code>Date</code> and
      <code>Object</code>:
    </p>
    <p><img src="object-date-inheritance.svg" /></p>
    <p>
      As you can see, there’s no link between <code>Date</code> and
      <code>Object</code>. They are independent, only
      <code>Date.prototype</code> inherits from <code>Object.prototype</code>.
    </p>
    <p>
      That’s an important difference of inheritance between built-in objects
      compared to what we get with <code>extends</code>.
    </p>
  </body>
</html>
